/*
 * InternalDBExtension.java
 *
 * Created on August 1, 2005, 3:57 PM
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

package lu.tudor.santec.settings;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;

import javax.swing.AbstractAction;
import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

import lu.tudor.santec.i18n.Translatrix;

import com.jgoodies.forms.layout.CellConstraints;
import com.jgoodies.forms.layout.FormLayout;

/**
 *
 * @author hermenj
 */

//***************************************************************************
//* Class Definition and Members                                            *
//***************************************************************************

public class ExtAppExtension extends PluginExtension implements ItemListener
    {

	private static final long serialVersionUID = 1L;

	private JTextField fileName;

	private JButton chooseFile;

	private JLabel fileNameLabel;

	private JFileChooser fileChooser;
		
	private final static int LINUX = 0;
	private final static int WINDOWS = 1;
	private final static int OTHER = 2;
	private int OS = 0;

	private String defaultWindows;

	private String defaultLinux;

	private String fileExt;
    
//***************************************************************************
//* Constructor                                                             *
//***************************************************************************

//---------------------------------------------------------------------------
/** Creates a new instance of I18nPlugin                                   */
//---------------------------------------------------------------------------

public ExtAppExtension(String desc, String fileExt, String defaultWindows, String defaultLinux) 
    {
    super (desc);
    
    this.fileExt = fileExt;
    this.defaultWindows = defaultWindows;
    this.defaultLinux = defaultLinux;
    
    String system = System.getProperty("os.name").toLowerCase();
    if (system.startsWith("linux")) {
    	OS = LINUX;
    } else if (system.startsWith("win")) {
    	OS = WINDOWS;
    } else {
    	OS = OTHER;
    }
        
    this.chooseFile = new JButton(new AbstractAction("...") {
		private static final long serialVersionUID = 1L;

		public void actionPerformed(ActionEvent e) {
			fileChooser = new JFileChooser(fileName.getText());
			fileChooser.setFileSelectionMode(JFileChooser.FILES_ONLY);
			fileChooser.showOpenDialog(getParent());
			if (fileChooser.getSelectedFile() != null) {
				fileName.setText(fileChooser.getSelectedFile()
						.getAbsolutePath());
			}
		}
	});
	this.fileNameLabel = new JLabel(Translatrix.getTranslationString("extApp.chooseApp")+":");
	this.fileName = new JTextField();
	this.fileName.setEditable(false);
	
	CellConstraints cc = new CellConstraints();
	FormLayout fileLayout = new FormLayout(
			"55dlu, 2dlu, pref:grow, 2dlu, 40dlu, 2dlu, 20dlu, 2dlu, 30dlu",
			"pref, 2dlu, pref, 2dlu");
	this.setLayout(fileLayout);
	JPanel fileChooserPanel = new JPanel(new BorderLayout());
	fileChooserPanel.add(this.fileName, BorderLayout.CENTER);
	fileChooserPanel.add(this.chooseFile, BorderLayout.EAST);
	// add Fields for file
	this.add(this.fileNameLabel, cc.xy(1, 3));
	this.add(fileChooserPanel, cc.xyw(3, 3, 7));
	
    }
    
//---------------------------------------------------------------------------

//***************************************************************************
//* Class Body                                                              *
//***************************************************************************

//---------------------------------------------------------------------------
/**
 * extensionAdded method will be called automatically AFTER the extension has been
 * added to the plugin. Method could be used for instance to add stationary
 * values to those of the plugin.
 */
//---------------------------------------------------------------------------

protected void extensionAdded ()
    {
	switch (OS) {
	case LINUX:
		setStationary (fileExt, defaultLinux);		
		break;
	case WINDOWS:
		setStationary (fileExt, defaultWindows);		
		break;
	default:
		setStationary (fileExt, defaultLinux);		
		break;
	}
    }
    
//---------------------------------------------------------------------------

public void revertToDefaults ()
    {
    setValue (fileExt, getDefault(fileExt));
    reflectSettings ();
    }

//---------------------------------------------------------------------------

public void updateSettings ()
    {
    setValue (fileExt, this.fileName.getText());
    }
    
//---------------------------------------------------------------------------

public void reflectSettings ()
    {
    this.fileName.setText((String)getValue(fileExt));
    }

public void itemStateChanged(ItemEvent e) {

}

//---------------------------------------------------------------------------

//***************************************************************************
//* End Of Class                                                            *
//***************************************************************************

}
