/*
 * InternalDBExtension.java
 *
 * Created on August 1, 2005, 3:57 PM
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

package lu.tudor.santec.settings;

import java.awt.event.ItemListener;
import java.awt.event.ItemEvent;

import javax.swing.JCheckBox;

/**
 *
 * @author nmac
 */

//***************************************************************************
//* Class Definition and Members                                            *
//***************************************************************************

public class InternalDBExtension extends PluginExtension implements ItemListener
    {
    private JCheckBox   m_UseInternal;
    
//***************************************************************************
//* Constructor                                                             *
//***************************************************************************

//---------------------------------------------------------------------------
/** Creates a new instance of I18nPlugin                                   */
//---------------------------------------------------------------------------

public InternalDBExtension() 
    {
    super ("Internal Database");
    m_UseInternal = new JCheckBox ("Use Internal DB");
    m_UseInternal.addItemListener (this);
    add (m_UseInternal);
    }
    
//---------------------------------------------------------------------------

//***************************************************************************
//* Class Body                                                              *
//***************************************************************************

//---------------------------------------------------------------------------
/**
 * extensionAdded method will be called automatically AFTER the extension has been
 * added to the plugin. Method could be used for instance to add stationary
 * values to those of the plugin.
 */
//---------------------------------------------------------------------------

protected void extensionAdded ()
    {
    setStationary ("InternalDB", new Boolean (false));
    }
    
//---------------------------------------------------------------------------

public void revertToDefaults ()
    {
    setValue ("InternalDB", getDefault("InternalDB"));
    reflectSettings ();
    }

//---------------------------------------------------------------------------

public void updateSettings ()
    {
    setValue ("InternalDB", new Boolean (m_UseInternal.isSelected()));
    }
    
//---------------------------------------------------------------------------

public void reflectSettings ()
    {
    Boolean l_UseInternal;
    
    l_UseInternal = (Boolean) getValue ("InternalDB"); 
    m_UseInternal.setSelected(l_UseInternal.booleanValue());
    }

//---------------------------------------------------------------------------

public void itemStateChanged(ItemEvent p_ItemEvent) 
    {   
    setPluginPanelEnabled (1, !m_UseInternal.isSelected());
    setPluginPanelEnabled (2, !m_UseInternal.isSelected());
    }
//***************************************************************************
//* End Of Class                                                            *
//***************************************************************************

}
