/*
 * SettingsPanel.java
 *
 * Created on July 11, 2005, 10:29 AM
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

package lu.tudor.santec.settings;

import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Frame;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.beans.PersistenceDelegate;
import java.beans.XMLDecoder;
import java.beans.XMLEncoder;
import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.LinkedHashMap;
import java.util.Vector;
import java.util.logging.Level;
import java.util.logging.Logger;

import javax.crypto.Cipher;
import javax.crypto.SecretKey;
import javax.crypto.SecretKeyFactory;
import javax.crypto.spec.DESKeySpec;
import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JToggleButton;
import javax.swing.ScrollPaneConstants;
import javax.swing.UIManager;
import javax.swing.event.EventListenerList;

import lu.tudor.santec.i18n.Relocalizable;
import lu.tudor.santec.i18n.Translatrix;

import com.jgoodies.forms.builder.ButtonBarBuilder;
import com.jgoodies.forms.factories.Borders;
import com.l2fprod.common.swing.JButtonBar;
import com.l2fprod.common.swing.plaf.blue.BlueishButtonBarUI;

import javax.swing.WindowConstants;
import java.awt.event.WindowListener;
import java.awt.event.WindowEvent;

/**
 *
 * @author nmac
 */

//***************************************************************************
//* Class Definition and Members                                            *
//***************************************************************************

public class SettingsPanel extends JDialog implements ActionListener,
        SettingListener,
        Relocalizable {
    private static final long serialVersionUID = 1L;
    
    protected static Logger m_Logger = Logger.getLogger("lu.tudor.santec.settings.SettingsPanel");
//    protected static final String PLUGIN_NAME = "PLUGIN_NAME";
    
    private EventListenerList   m_SettingListeners;
    
//    private Vector              m_Settings;
    private LinkedHashMap  m_Settings;
    private Vector              m_Plugins;
    private Hashtable           m_PersistenceDelegates;
//    private Hashtable           m_PluginLookup;
    
    private JScrollPane         m_PluginScroller;
    private JButtonBar          m_PluginBar;
    private ButtonGroup         m_PluginGroup;
    private JPanel              m_ButtonPanel;
    private JButton             m_Apply;
    private JButton             m_Okay;
    private JButton             m_Cancel;
    private JButton             m_Revert;
    
    private Component           m_CurrentComponent;
    private double              m_ButtonPanelHeight;
    
    private File                m_SettingsFile;
    private SecretKey           m_SecretKey;
    private String              m_EncryptionPassword;
    
    private static final Dimension c_PreferredDimension = new Dimension(600,400);
    private static final String    c_PasswordPadding    = "        ";
    private static final double    c_PluginGap          = 10;
    
//***************************************************************************
//* Constructor                                                             *
//***************************************************************************
    
//---------------------------------------------------------------------------
    /** Creates a new instance of SettingsPanel */
//---------------------------------------------------------------------------
    
    public SettingsPanel(Frame p_Owner) {
        super(p_Owner,Translatrix.getTranslationString("SettingsPanelTitle"),true);
        
        ButtonBarBuilder l_Builder;
        
        
        m_SettingListeners = new EventListenerList();
        
        m_Plugins              = new Vector();
//        m_Settings             = new Vector();
        m_Settings = new LinkedHashMap();
        m_PersistenceDelegates = new Hashtable();
//        m_PluginLookup         = new Hashtable();
        
        this.getContentPane().setLayout(new BorderLayout());
        this.setSize(c_PreferredDimension);
        
        m_PluginBar = new JButtonBar(JButtonBar.VERTICAL);
        m_PluginBar.setUI(new BlueishButtonBarUI());
        m_PluginGroup = new ButtonGroup();
        
        m_PluginScroller = new JScrollPane(m_PluginBar);
        m_PluginScroller.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);
        m_PluginScroller.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_AS_NEEDED);
        m_PluginScroller.getVerticalScrollBar().setUnitIncrement(10);
        
        this.getContentPane().add("West",m_PluginScroller);
        
        l_Builder = new ButtonBarBuilder();
        
        
        m_Revert = new JButton(Translatrix.getTranslationString("RevertOption"));
        m_Revert.addActionListener(this);
        
        m_Cancel = new JButton(Translatrix.getTranslationString("CancelOption"));
        m_Cancel.addActionListener(this);
        
        l_Builder.addGlue();
        l_Builder.addGridded(m_Revert );
        l_Builder.addUnrelatedGap();
        l_Builder.addUnrelatedGap();
        l_Builder.addGridded(m_Cancel);
        l_Builder.addRelatedGap();
        
        m_Apply = new JButton(Translatrix.getTranslationString("ApplyOption"));
        m_Apply.addActionListener(this);
        
//    l_Builder.add (m_Apply,l_Constraints.xy (6,2));
        l_Builder.addGridded(m_Apply);
        l_Builder.addRelatedGap();
        
        m_Okay = new JButton(Translatrix.getTranslationString("OkText"));
        m_Okay.addActionListener(this);
        
//    l_Builder.add (m_Okay,l_Constraints.xy (8,2));
        l_Builder.addGridded(m_Okay);
        
        m_ButtonPanel =  l_Builder.getPanel();
        m_ButtonPanel.setBorder(Borders.DLU4_BORDER);
        
        this.getContentPane().add("South", m_ButtonPanel);
        
        m_ButtonPanelHeight = m_ButtonPanel.getPreferredSize().getHeight();
        
        m_SettingsFile       = new File("settings.xml");
        m_EncryptionPassword = null;
        m_SecretKey          = null;
        
        // add a suitable window listener:
        this.setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);
        
        WindowListener closeWindowAction = new WindowListener() {
            public void windowClosing(WindowEvent e) {
                // do the same as for the cancel button:
                reflectSettings();
                setVisible(false);
            }
            
            public void windowClosed(WindowEvent e) {
            }
            
            public void windowOpened(WindowEvent e) {
            }
            
            public void windowIconified(WindowEvent e) {
            }
            
            public void windowDeiconified(WindowEvent e) {
            }
            
            public void windowActivated(WindowEvent e) {
            }
            
            public void windowDeactivated(WindowEvent e) {
            }
        };
        this.addWindowListener(closeWindowAction);
        
    }
    
//***************************************************************************
//* Class Primitives                                                        *
//***************************************************************************
    
//---------------------------------------------------------------------------
    /**
     * displays the component specified by p_Component. Method will be called whenever
     * Plugin selection changes.
     * @param p_Component specifies the (plugin) component to be shown.
     */
//---------------------------------------------------------------------------
    
    public void showComponent(Component p_Component) {
        SettingsPlugin  l_Plugin;
        
        if (m_CurrentComponent != null) this.getContentPane().remove(m_CurrentComponent);
        this.getContentPane().add("Center", m_CurrentComponent = p_Component);
        
        l_Plugin = (SettingsPlugin) p_Component;
        m_Revert.setEnabled(l_Plugin.hasDefaults());
        
        validate();
        repaint();
    }
    
//---------------------------------------------------------------------------
    /**
     * generates the encryption cipher based on the previously set encryption password
     * @return encryption cipher
     */
//---------------------------------------------------------------------------
    
    private Cipher getEncryptionCipher() {
        DESKeySpec          l_KeySpecification;
        SecretKeyFactory    l_KeyFactory;
        Cipher              l_Cipher;
        
        l_Cipher = null;
        
        try {
            if (m_SecretKey == null) {
                l_KeySpecification = new DESKeySpec(m_EncryptionPassword.getBytes());
                l_KeyFactory       = SecretKeyFactory.getInstance("DES");
                m_SecretKey        = l_KeyFactory.generateSecret(l_KeySpecification);
            }
            
            l_Cipher = Cipher.getInstance("DES/ECB/PKCS5Padding");
            l_Cipher.init(Cipher.ENCRYPT_MODE, m_SecretKey);
        } catch (Exception p_Exception) {
            m_Logger.log(Level.WARNING,"Generation of Encryption Cipher failed!",p_Exception);
        }
        
        return l_Cipher;
    }
    
//---------------------------------------------------------------------------
    /**
     * generates the decryption cipher based on the previously set encryption password
     * @return decryption cipher
     */
//---------------------------------------------------------------------------
    
    private Cipher getDecryptionCipher() {
        DESKeySpec          l_KeySpecification;
        SecretKeyFactory    l_KeyFactory;
        Cipher              l_Cipher;
        
        l_Cipher = null;
        
        try {
            if (m_SecretKey == null) {
                l_KeySpecification = new DESKeySpec(m_EncryptionPassword.getBytes());
                l_KeyFactory       = SecretKeyFactory.getInstance("DES");
                m_SecretKey        = l_KeyFactory.generateSecret(l_KeySpecification);
            }
            
            l_Cipher = Cipher.getInstance("DES/ECB/PKCS5Padding");
            l_Cipher.init(Cipher.DECRYPT_MODE, m_SecretKey);
        } catch (Exception p_Exception) {
            m_Logger.log(Level.WARNING,"Generation of Decryption Cipher failed!",p_Exception);
        }
        
        return l_Cipher;
    }
    
//***************************************************************************
//* Class Body                                                              *
//***************************************************************************
    
//---------------------------------------------------------------------------
    
    public void addSettingListener(SettingListener p_Listener) {
        if (m_SettingListeners != null)
            m_SettingListeners.add(SettingListener.class, p_Listener);
    }
    
//---------------------------------------------------------------------------
    
    public void removeSettingListener(SettingListener p_Listener) {
        if (m_SettingListeners != null)
            m_SettingListeners.remove(SettingListener.class, p_Listener);
    }
    
//---------------------------------------------------------------------------
    
    public void fireSettingEvent(SettingEvent p_Event) {
        Object[] l_Listeners;
        int      l_Index;
        
        l_Listeners = m_SettingListeners.getListenerList();
        
        for (l_Index = 0; l_Index < l_Listeners.length; l_Index+=2) {
            if (l_Listeners [l_Index] == SettingListener.class) {
                ((SettingListener)l_Listeners [l_Index+1]).settingChanged(p_Event);
            }
        }
    }
    
//---------------------------------------------------------------------------
    /**
     * instructs current plugin to revert to default values.
     */
//---------------------------------------------------------------------------
    
    public void revertToDefaults() {
        SettingsPlugin  l_Plugin;
        
        l_Plugin = (SettingsPlugin)m_CurrentComponent;
        
        l_Plugin.revertToDefaults();
    }
    
//---------------------------------------------------------------------------
    /**
     * updates centraly stored settings by calling updateSettings method on all plugins
     */
//---------------------------------------------------------------------------
    
    public void updateSettings() {
        SettingsPlugin  l_Plugin;
        int             l_Index;
        
        //=======================================================================
        // Making sure settings are up-to-date. Calling updateSettings method
        // on all Plugins makes sure this is so.
        //=======================================================================
        
        for (l_Index = 0; l_Index < m_Plugins.size(); l_Index++) {
            l_Plugin = (SettingsPlugin)m_Plugins.elementAt(l_Index);
            l_Plugin.updateSettings();
        }
    }
    
//---------------------------------------------------------------------------
    /**
     * updates plugins so that they reflect centraly stored settings.
     */
//---------------------------------------------------------------------------
    
    public void reflectSettings() {
        SettingsPlugin  l_Plugin;
        int             l_Index;
        
        //=======================================================================
        // Making sure that plugins reflect centraly stored settings.
        // Calling reflectSettings method on all Plugins makes sure this is so
        //=======================================================================
        
        for (l_Index = 0; l_Index < m_Plugins.size(); l_Index++) {
            l_Plugin = (SettingsPlugin)m_Plugins.elementAt(l_Index);
            l_Plugin.reflectSettings();
        }
    }
    
//---------------------------------------------------------------------------
    /**
     * serializes settings as XML to stream specified by p_SettingsStream
     * @param p_SettingsStream specifies stream to write settings to
     * @throws IOException
     */
//---------------------------------------------------------------------------
    
    public void writeSettings(OutputStream p_SettingsStream) throws IOException {
        XMLEncoder          l_Encoder;
        Enumeration         l_Classes;
        String              l_ClassName;
        PersistenceDelegate l_Delegate;
        
        //=======================================================================
        // Serialize Settings as XML
        //=======================================================================
        
        l_ClassName = new String("");
        
        try {
            l_Encoder = new XMLEncoder(p_SettingsStream);
            
            //===================================================================
            // Set Persistence Delegates specified by plugins
            //===================================================================
            
            for (l_Classes = m_PersistenceDelegates.keys(); l_Classes.hasMoreElements() ;) {
                l_ClassName = (String)l_Classes.nextElement();
                l_Delegate  = (PersistenceDelegate) m_PersistenceDelegates.get(l_ClassName);
                
                l_Encoder.setPersistenceDelegate(Class.forName(l_ClassName), l_Delegate);
            }
            
            try {
                l_Encoder.writeObject(m_Settings);
                l_Encoder.flush();
            } finally // No matter what happens, close object stream.
            {
                l_Encoder.close();
            }
        } catch (ClassNotFoundException p_Exception) {
            m_Logger.log(Level.WARNING,"Failed to set Persistence Delegate for Class " + l_ClassName + "!",p_Exception);
        }
        
        finally // No matter what happens, close settings stream.
        {
            p_SettingsStream.close();
        }
    }
    
//---------------------------------------------------------------------------
    /**
     * reads serialized settings in XML format from specified stream
     * @param p_SettingsStream specifies stream to read serialized settings from.
     * @throws IOException
     */
//---------------------------------------------------------------------------
    
    protected void readSettings(InputStream p_SettingsStream) throws IOException {
        XMLDecoder      l_Decoder;
        
        //=======================================================================
        // De-Serialize Settings from XML
        //=======================================================================
        
        try {
            l_Decoder = new XMLDecoder(p_SettingsStream);
            
            try {
            	LinkedHashMap loadedSettings = (LinkedHashMap) l_Decoder.readObject();
            	for (Iterator iter = loadedSettings.keySet().iterator(); iter.hasNext();) {
					String pluginName = (String) iter.next();
					m_Settings.put(pluginName, loadedSettings.get(pluginName));
				}

            } catch(Exception e) {
            	m_Logger.log(Level.WARNING,"Reading of Settings failed, Settings File not Compatible",e);
            }
            finally // No matter what happens, close object stream.
            {
                l_Decoder.close();
            }
        } finally // No matter what happens, close settings stream.
        {
            p_SettingsStream.close();
        }
    }
    
    
//---------------------------------------------------------------------------
    
    public void setEncryptionPassword(String p_Password) {
        if (p_Password != null) {
            if (p_Password.length() < 8)
                p_Password += c_PasswordPadding.substring(p_Password.length(),
                        c_PasswordPadding.length());
            
            m_EncryptionPassword = p_Password;
            m_SecretKey          = null;
        }
    }
    
//---------------------------------------------------------------------------
    /**
     * adds the plugin specified by p_Plugin to this Settings panel
     * @param p_PLugin adds the specified plugin to this panel
     */
//---------------------------------------------------------------------------
    
    public void addPlugin(SettingsPlugin p_Plugin) {
        Action          l_Action;
        final Component l_Component;
        JToggleButton   l_Button;
        
        int             l_PluginID;
        Dimension       l_PluginSize;
        Dimension       l_ButtonSize;
        Dimension       l_PreferredSize;
        Dimension       l_ScrollerSize;
        double          l_Width;
        double          l_Height;
        
        if (p_Plugin == null) return;
        
        //=======================================================================
        // First step consists in telling the plugin that its owned by this panel.
        // Next, central setting store will be expanded with additional hash space
        // to accomodate new plugins' settings. Last but not least, the new plugin
        // will be added to the list of owned plugins.
        //=======================================================================
        
        l_PluginID  = m_Plugins.size();
        p_Plugin.setOwner(this, l_PluginID);

        m_Settings.put(p_Plugin.getName(),new Hashtable());
        m_Plugins.add(p_Plugin);
//        m_PluginLookup.put(p_Plugin.getName(), new Integer(l_PluginID));
        
        //=======================================================================
        // Adjust height of panel to accomodate heighest plugin
        //=======================================================================
        
        l_Component  = p_Plugin;
        l_PluginSize = p_Plugin.getPreferredSize();
        l_PreferredSize = getSize();
        
        if (l_PluginSize.getHeight() > (l_PreferredSize.getHeight() - m_ButtonPanelHeight)) {
            l_PreferredSize.setSize(l_PreferredSize.getWidth(),(l_PluginSize.getHeight() + m_ButtonPanelHeight));
            setSize(l_PreferredSize);
        }
        
        //=======================================================================
        // Every plugin is represented by an icon in the left Button bar. In order
        // to make sure that plugin will display after clicking on corresponding
        // button, we'll have to create a dedicated action for new plugin an
        // associate with the corresponding button.
        //=======================================================================
        
        l_Action = new AbstractAction(p_Plugin.getLabel(),
                p_Plugin.getIcon()) {
					private static final long serialVersionUID = 1L;

			public void actionPerformed(ActionEvent p_Event) {
                showComponent(l_Component);
            }
        };
        
        l_Button = new JToggleButton(l_Action);
        l_Button.setToolTipText(p_Plugin.getTooltip());
        
        m_PluginBar.add(l_Button);
        m_PluginGroup.add(l_Button);
        
        //=======================================================================
        // Adjust width of plugin bar to accomodate widest plugin
        //=======================================================================
        
        l_ButtonSize    = l_Button.getPreferredSize();
        l_PreferredSize = m_PluginBar.getPreferredSize();
        l_ScrollerSize  = m_PluginScroller.getVerticalScrollBar().getMaximumSize();
        
        l_Width = l_PreferredSize.getWidth() - l_ScrollerSize.getWidth() - c_PluginGap;
        
        if (l_ButtonSize.getWidth() > l_Width) {
            l_Width  = l_ButtonSize.getWidth()     + l_ScrollerSize.getWidth() + c_PluginGap;
            
            l_Height = l_PreferredSize.getHeight() + l_ButtonSize.getHeight();
            l_PreferredSize.setSize(l_Width,l_Height);
            m_PluginBar.setPreferredSize(l_PreferredSize);
        }
        
        //=======================================================================
        // Make sure first plugin is selected
        //=======================================================================
        
        if (m_PluginGroup.getSelection() == null) {
            l_Button.setSelected(true);
            showComponent(l_Component);
        }
    }
    
//---------------------------------------------------------------------------
    /**
     * adds the Persistence Delegate specified by p_Delegate for class specified by p_Class.
     * Persistence Delegates take the responsibility for expressing the state of an instance
     * of a given class. XMLEncoder  class is exclusively designed for the purpose of archiving
     * graphs of JavaBeans as textual representations of their public properties. Persistence
     * Delegates are required for storing non JavaBeans compliant classes.
     * @param p_Class specifies the class to add a Persistence Delegate for
     * @param p_Delegate specifies the persistence delegate object to be associated with specifed class
     */
//---------------------------------------------------------------------------
    
    public void addPersistenceDelegate(Class p_Class, PersistenceDelegate p_Delegate) {
        if ((p_Class != null) && (p_Delegate != null))
            m_PersistenceDelegates.put(p_Class.getName(), p_Delegate);
    }
    
//---------------------------------------------------------------------------
    /**
     * sets the value specified by p_Key to the value specified by p_Value for plugin
     * specified by p_PluginID
     * @param p_PluginID specifies the plugin to set the value for
     * @param p_Key specifies the value to be set
     * @param p_Value specifies the value itself
     */
//---------------------------------------------------------------------------
    
    public void setValue(String p_PluginName, String p_Key, Object p_Value) {
        Hashtable   l_Settings = null;
        
//        if ((p_PluginID >= 0) && (p_PluginID < m_Settings.size())) {
//            l_Settings = (Hashtable) m_Settings.elementAt(p_PluginID);
//        }
        
        l_Settings = (Hashtable) m_Settings.get(p_PluginName);
        
        if (l_Settings != null) {
            l_Settings.put(p_Key,p_Value);
        }
    }
    
//---------------------------------------------------------------------------
    /**
     * returns the value specified by p_Key for plugin specified by p_PluginID
     * @param p_PluginID specifies the plugin to get the value for
     * @param specifies the value to get
     * @return the value specified by p_Key if existing, <B>NULL</B> otherwise
     */
//---------------------------------------------------------------------------
    
//    public Object getValue(int p_PluginID, String p_Key) {
//        Hashtable   l_Settings = null;
//        Object      l_Value    = null;
//        
//        if ((p_PluginID >= 0) && (p_PluginID < m_Settings.size())) {
//            l_Settings = (Hashtable) m_Settings.elementAt(p_PluginID);
//        }
//        
//        if (l_Settings != null) {
//            if (l_Settings.containsKey(p_Key))
//                l_Value = l_Settings.get(p_Key);
//        }
//        
//        return l_Value;
//    }
    
//---------------------------------------------------------------------------
    /**
     * returns the value specified by p_Key for plugin specified by p_PluginName
     * @param p_PluginName specifies the plugin to get the value for
     * @param specifies the value to get
     * @return the value specified by p_Key if existing, <B>NULL</B> otherwise
     */
//---------------------------------------------------------------------------
    
    public Object getValue(String p_PluginName, String p_Key) {
        Object  l_Value = null;
        
        l_Value = ((Hashtable)m_Settings.get(p_PluginName)).get(p_Key);
        
        return l_Value;
    }
    
//---------------------------------------------------------------------------
    /**
     * Method is part of the Relocalizable interface. The method does everything
     * required to reflect changes of active Locale
     */
//---------------------------------------------------------------------------
    
    public void relocalize() {
        SettingsPlugin  l_Plugin;
        int             l_Index;
        
        this.setTitle(Translatrix.getTranslationString("SettingsPanelTitle"));
        
        for (l_Index = 0; l_Index < m_Plugins.size(); l_Index++) {
            l_Plugin = (SettingsPlugin)m_Plugins.elementAt(l_Index);
            l_Plugin.relocalize();
        }
        
        if (m_Revert != null) m_Revert.setText(Translatrix.getTranslationString("RevertOption"));
        if (m_Cancel != null) m_Cancel.setText(Translatrix.getTranslationString("CancelOption"));
        if (m_Apply != null)  m_Apply.setText(Translatrix.getTranslationString("ApplyOption"));
        if (m_Okay != null)   m_Okay.setText(Translatrix.getTranslationString("OkText"));
    }
    
//---------------------------------------------------------------------------
    
    public void actionPerformed(ActionEvent p_ActionEvent) {
        if (p_ActionEvent.getSource() instanceof JButton) {
            if (p_ActionEvent.getSource() == m_Revert) {
                revertToDefaults();
            }
            
            if (p_ActionEvent.getSource() == m_Okay) {
                updateSettings();
                saveSettings();
                setVisible(false);
            }
            if (p_ActionEvent.getSource() == m_Apply) {
                updateSettings();
                saveSettings();
            }
            if (p_ActionEvent.getSource() == m_Cancel) {
                reflectSettings();
                setVisible(false);
            }
        }
    }
    
//---------------------------------------------------------------------------
    
    public void settingChanged(SettingEvent p_SettingEvent) {
        m_Logger.log(Level.INFO,"Setting "
                + p_SettingEvent.getSetting()
                + " changed in plugin "
                + p_SettingEvent.getPluginName());
    }
    
//---------------------------------------------------------------------------
    /**
     * sets settings file to file specified by p_SettingsFile. Default value for settings
     * file is <I>settings.xml</I>
     * @param p_SettingsFile specifies the new file for setting storage
     */
//---------------------------------------------------------------------------
    
    public void setSettingsFile(File p_SettingsFile) {
        if (p_SettingsFile != null) m_SettingsFile = p_SettingsFile;
    }
    
//---------------------------------------------------------------------------
    /**
     * saves current settings to settings file. Default settings file is <I>settings.xml</I>.
     * Use setSettingsFile method to change default settings file.
     * @see setSettingsFile
     */
//---------------------------------------------------------------------------
    
    public void saveSettings() {
        FileOutputStream        l_Stream;
        BufferedOutputStream    l_BufferedStream;
//    CipherOutputStream      l_CipherStream;
//    Cipher                  l_Cipher;
        
//    l_Cipher = getEncryptionCipher ();
        
        try {
            l_Stream = new FileOutputStream(m_SettingsFile);
            l_BufferedStream = new BufferedOutputStream(l_Stream);
//            l_CipherStream   = new CipherOutputStream (l_BufferedStream,l_Cipher);
            
            writeSettings(l_BufferedStream);
        } catch(Exception p_Exception) {
            m_Logger.log(Level.WARNING,"Saving Settings failed",p_Exception);
        }
    }
    
//---------------------------------------------------------------------------
    /**
     * loads settings from settings file. Default settings file is <I>settings.xml</I>.
     * Use setSettingsFile method to change default settings file.
     * @see setSettingsFile
     */
//---------------------------------------------------------------------------
    
    public void loadSettings() {
        FileInputStream     l_Stream;
        BufferedInputStream l_BufferedStream;
//    CipherInputStream   l_CipherStream;
//    Cipher              l_Cipher;
        
//    l_Cipher     = getDecryptionCipher ();
        
        if ((m_SettingsFile != null) && (m_SettingsFile.isFile())) {
            try {
                l_Stream         = new FileInputStream(m_SettingsFile);
                l_BufferedStream = new BufferedInputStream(l_Stream);
                //       l_CipherStream   = new CipherInputStream (l_BufferedStream,l_Cipher);
                readSettings(l_BufferedStream);
                
            } catch(Exception p_Exception) {
                m_Logger.log(Level.WARNING,"Loading Settings failed",p_Exception);
            }
        }
        
        reflectSettings();
    }
        
//***************************************************************************
//* End Of Class                                                            *
//***************************************************************************
    
    public static void main(String[] args) throws Exception {
        SettingsPanel l_Panel;
        I18nPlugin      l_I18nPlugin, l_I18nListPlugin;
        DatabasePlugin  l_DatabasePlugin;
        LoggingPlugin l_LoggingPlugin;
        InternalDBExtension l_Extension;
        LookAndFeelPlugin l_LookAndFeelPlugin;
        StartScriptPlugin l_StartSkriptPlugin;
        ExternalApplicationPlugin l_ExtAppPlugin;
        
        UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
        
        Translatrix.loadSupportedLocales("lu.tudor.santec.settings.resources.supportedLocales");
        Translatrix.addBundle("lu.tudor.santec.settings.resources.WidgetResources");
        
        l_Panel          = new SettingsPanel(null);
        
        // create i18n plugin
        l_I18nPlugin     = new I18nPlugin("i18n");
        //  create i18n plugin
        l_I18nListPlugin = new I18nPlugin("i18nList", true);
        
        
        // create database plugin
        l_DatabasePlugin = new DatabasePlugin("database");
        
        l_DatabasePlugin.addDatabaseDriver(DatabasePlugin.HSQLDB);
        l_DatabasePlugin.addDatabaseDriver(DatabasePlugin.MYSQL);
        l_DatabasePlugin.addDatabaseDriver(DatabasePlugin.POSTGRESQL);
        
        l_DatabasePlugin.loadDefaults(new File("DatabasePlugin.xml"));
        
        l_Extension = new InternalDBExtension();
        l_DatabasePlugin.addExtensionAt(l_Extension,0);
        
        // create logging plugin
        l_LoggingPlugin = new LoggingPlugin("logging");
        
        // 	create look and Feel plugin
        l_LookAndFeelPlugin = new LookAndFeelPlugin("lnf");
        
        // create StartScript plugin
        l_StartSkriptPlugin = new StartScriptPlugin("script", "runSettings", "settings.jar");
        
        l_ExtAppPlugin = new ExternalApplicationPlugin("extapp");
        l_ExtAppPlugin.addExtension(new ExtAppExtension("Adobe PDF", "pdf", "acrord32", "acroread"));
        
        // add all plugins
        l_Panel.addPlugin(l_I18nPlugin);
        l_Panel.addPlugin(l_I18nListPlugin);
        l_Panel.addPlugin(l_DatabasePlugin);
        l_Panel.addPlugin(l_LoggingPlugin);
        l_Panel.addPlugin(l_LookAndFeelPlugin);
        l_Panel.addPlugin(l_StartSkriptPlugin);
        l_Panel.addPlugin(l_ExtAppPlugin);
        
        l_Panel.addSettingListener(l_Panel);
        
        l_Panel.loadSettings();
        
        l_Panel.setDefaultCloseOperation(JDialog.EXIT_ON_CLOSE);
        
        l_Panel.setVisible(true);
    }
}



